Package org.kapott.hbci.GV_Result

## Interface HBCIJobResult

All Known Implementing Classes:
  `AbstractGVRLastSEPA`, `GVRAccInfo`, `GVRCardList`, `GVRDauerEdit`, `GVRDauerList`, `GVRDauerNew`, `GVRFestCondList`, `GVRFestList`, `GVRInfoList`, `GVRInfoOrder`, `GVRInstUebSEPA`, `GVRKontoauszug`, `GVRKUms`, `GVRLastB2BSEPA`, `GVRLastCOR1SEPA`, `GVRLastSEPA`, `GVRSaldoReq`, `GVRStatus`, `GVRTANList`, `GVRTANMediaList`, `GVRTermUeb`, `GVRTermUebEdit`, `GVRTermUebList`, `GVRWPDepotList`, `GVRWPDepotUms`, `GVRWPStammData`, `HBCIJobResultImpl`

    public interface HBCIJobResult

Basis-Interface für die Rückgabedaten von ausgeführten HBCI-Jobs. Alle Klassen in diesem Package implementieren dieses Interface. In ihm werden Methoden und Felder für die Auswertung von Status-Informationen und für die Rückgabe der Antwortdaten in ihrer ursprünglichen Form (wie sie in der HBCI-Nachricht enthalten waren) bereitgestellt.

### Method Summary

All Methods Instance Methods Abstract Methods
`java.lang.String` `getDialogId()` Gibt die Dialog-ID zurück, unter der der dazugehörige Job ausgeführt wurde.
`HBCIStatus` `getGlobStatus()` Gibt ein Status-Objekt zurück, welches Status-Informationen zur HBCI-Nachricht selbst enthält, in der die Job-Auftragsdaten übermittelt wurden.
`java.lang.String` `getJobId()` Gibt einen Job-Identifikationsstring zurück, mit dessen Hilfe sich der Job für das `Statusprotokoll` identifizieren lässt
`HBCIStatus` `getJobStatus()` Gibt ein Status-Objekt zurück, welches Status-Informationen über das Auftragssegment enthält, in dem die Job-Auftragsdaten übermittelt wurden.
`java.lang.String` `getMsgNum()` Gibt die Nachrichtennummer innerhalb des Dialoges zurück, in dem der dazugehörige Job ausgeführt wurde.
`HBCIPassport` `getPassport()` Gibt das Passport-Objekt zurück, für welches der Job erzeugt wurde.
`java.util.Properties` `getResultData()` Gibt die Job-Antwortdaten im Rohformat zurück.
`int` `getRetNumber()` Gibt zurück, wieviele HBCI-Statuscode (siehe `HBCIRetVal`) in den Statusdaten zu diesem Job gespeichert sind.
`HBCIRetVal` `getRetVal​(int idx)` Gibt einen bestimmten HBCI-Statuscode aus den Job-Statusinformationen zurück.
`java.lang.String` `getSegNum()` Gibt die Segmentnummer des Segmentes innerhalb der Auftragsnachricht zurück, in welchem die Job-Daten übertragen wurden.
`boolean` `isOK()` Gibt an, ob der Job erfolgreich ausgeführt wurde oder nicht.

### Method Detail

#### getRetNumber

    int getRetNumber()

Gibt zurück, wieviele HBCI-Statuscode (siehe `HBCIRetVal`) in den Statusdaten zu diesem Job gespeichert sind. Dabei werden die globalen Statusinformationen (die sich auf die gesamte Nachricht beziehen und nicht nur auf ein Segment dieses Jobs) nicht mitgezählt

Returns:
  Anzahl der HBCI-Statuscodes in den Job-Statusinformationen

#### getRetVal

    HBCIRetVal getRetVal​(int idx)

Gibt einen bestimmten HBCI-Statuscode aus den Job-Statusinformationen zurück. Die Anzahl der hier zur Verfügung stehenden Rückgabewerte kann mit `getRetNumber()` ermittelt werden.

Parameters:
  `idx` - Indenummer des HBCI-Statuscodes (von 0 bis Anzahl-1)
Returns:
  einen HBCI-Statuscode

#### isOK

    boolean isOK()

Gibt an, ob der Job erfolgreich ausgeführt wurde oder nicht.

Bei `true` ist der Job mit Sicherheit erfolgreich ausgeführt worden. Bei `false` kann es sein, dass der Job trotzdem ausgeführt wurde und nur die Antwortnachricht vom HBCI-Server nicht empfangen werden konnte oder fehlerhaft war. In diesem Fall sollte also die Fehlermeldung aus `jobStatus.getErrorString()` bzw. `globStatus.getErrorString()` genau ausgewertet werden.

Returns:
  `true`, wenn der Auftrag mit Sicherheit erfolgreich eingereicht/ausgeführt wurde; sonst `false`

#### getDialogId

    java.lang.String getDialogId()

Gibt die Dialog-ID zurück, unter der der dazugehörige Job ausgeführt wurde. Wird hauptsächlich intern verwendet. Zur Bereitstellung einer eindeutigen ID für den Job siehe `getJobId()`.

Returns:
  Dialog-ID des Dialoges, in welchem der Job ausgeführt wurde

#### getMsgNum

    java.lang.String getMsgNum()

Gibt die Nachrichtennummer innerhalb des Dialoges zurück, in dem der dazugehörige Job ausgeführt wurde. Wird hauptsächlich intern verwendet. Zur Bereitstellung einer eindeutigen ID für den Job siehe `getJobId()`.

Returns:
  Nachrichtennummer der Nachricht, in welcher der Job ausgeführt wurde

#### getSegNum

    java.lang.String getSegNum()

Gibt die Segmentnummer des Segmentes innerhalb der Auftragsnachricht zurück, in welchem die Job-Daten übertragen wurden. Wird hauptsächlich intern verwendet. Zur Bereitstellung einer eindeutigen ID für den Job siehe `getJobId()`.

Returns:
  Segmentnummer des Auftragssegmentes

#### getJobId

    java.lang.String getJobId()

Gibt einen Job-Identifikationsstring zurück, mit dessen Hilfe sich der Job für das `Statusprotokoll` identifizieren lässt

Returns:
  die Job-Identifikationsnummer für den dazugehörigen Auftrag

#### getResultData

    java.util.Properties getResultData()

Gibt die Job-Antwortdaten im Rohformat zurück. Für die Keys des Properties-Objektes gibt es zwei Ausprägungen:

- mit Prefix `content.` bzw. `content_NUM.`:
  Dieses Key-Value-Paar stellt ein Datenelement aus der Antwortnachricht dar. Der Rest des Keys (nach dem Prefix) gibt dabei den Lowlevel-Namen des Ergebnisdatenelementes an. Eine Liste aller möglichen Lowlevel-Namen kann zur Laufzeit mit `HBCIHandler.getLowlevelJobResultNames(String)` oder mit `HBCIJob.getJobResultNames()` ermittelt werden.

- mit Prefix `basic`:
  Hier werden jobinterne Daten gespeichert:

  - `basic.dialogid` enthält die Dialog-ID, mit der der Job ausgeführt wurde
  - `basic.msgnum` enthält die Nachrichtennummer innerhalb des Dialoges, in dem der Job ausgeführt wurde
  - `basic.segnum` enthält die Segmentnummer innerhalb der Nachricht, in der der Job ausgeführt wurde

  Diese Daten sollten niemals manuell ausgewertet werden, da es diese `basic`-Daten in Zukunft nicht mehr geben wird!

Returns:
  die Antwortdaten im Rohformat

#### getGlobStatus

    HBCIStatus getGlobStatus()

Gibt ein Status-Objekt zurück, welches Status-Informationen zur HBCI-Nachricht selbst enthält, in der die Job-Auftragsdaten übermittelt wurden.

Returns:
  Statusinformationen zur Auftragsnachricht

#### getJobStatus

    HBCIStatus getJobStatus()

Gibt ein Status-Objekt zurück, welches Status-Informationen über das Auftragssegment enthält, in dem die Job-Auftragsdaten übermittelt wurden.

Returns:
  Status-Informationen, die genau diesen Job betreffen

#### getPassport

    HBCIPassport getPassport()

Gibt das Passport-Objekt zurück, für welches der Job erzeugt wurde.

Returns:
  Passport-Objekt